//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Grids.hpp>
#include <Menus.hpp>

class TMyTank;

//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TSplitter *Splitter1;
        TPanel *pnlView;
        TPaintBox *pbxView;
        TStatusBar *stbMain;
        TPanel *pnlRight;
        TSplitter *Splitter2;
        TDrawGrid *grdTile;
        TTreeView *tvwTiles;
        TMainMenu *mnuMain;
        TMenuItem *F1;
        TMenuItem *mnuChooseLevel;
        TMenuItem *mnuSave;
        TMenuItem *N1;
        TMenuItem *mnuRestoreLevel;
        TMenuItem *N3;
        TMenuItem *mnuExit;
        TMenuItem *E1;
        TMenuItem *mnuEditTerr;
        TMenuItem *mnuEditTerrItem;
        TMenuItem *mnuEditItem;
        TMenuItem *mnuEditHiTerrItem;
        TMenuItem *mnuEditRole;
        TMenuItem *N2;
        TMenuItem *mnuRemoveItem;
        TMenuItem *N4;
        TMenuItem *mnuResetMap;
        TMenuItem *mnuResetAllMap;
        TMenuItem *V1;
        TMenuItem *mnuShowGrid;
        TMenuItem *mnuShowSpeicalArea;
        TMenuItem *mnuDrawEditLayerOnly;
        TMenuItem *H1;
        TMenuItem *mnuAbout;
        void __fastcall mnuAboutClick(TObject *Sender);
        void __fastcall mnuExitClick(TObject *Sender);
        void __fastcall mnuRestoreLevelClick(TObject *Sender);
        void __fastcall mnuChooseLevelClick(TObject *Sender);
        void __fastcall mnuSaveClick(TObject *Sender);
        void __fastcall mnuEditKindClick(TObject *Sender);
        void __fastcall mnuRemoveItemClick(TObject *Sender);
        void __fastcall mnuResetMapClick(TObject *Sender);
        void __fastcall mnuShowSomethingClick(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall pbxViewPaint(TObject *Sender);
        void __fastcall pbxViewMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall pbxViewMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall pbxViewMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall grdTileDrawCell(TObject *Sender, int ACol,
          int ARow, TRect &Rect, TGridDrawState State);
        void __fastcall tvwTilesChange(TObject *Sender, TTreeNode *Node);
private:	// User declarations
    int FEditLayer; // ثesҦ
    int FLevelNo; // ثes誺d
    bool FModified; // JdO_ʹL

    TMyTank* FTank; // ⪫
    Graphics::TBitmap* FBackBitmap; // double-buffering ΪI bitmap

    int FSelectionX, FSelectionY; // ƹЦm
    TMouseButton FButtonPressed; // ƹ䪬A

    int __fastcall GetSelectionWidth();
    int __fastcall GetSelectionHeight();

    void __fastcall DrawBackBitmap(); // øsI bitmap
    void __fastcall UpdateView(); // sse
    void __fastcall UpdateControlStatus();

    void __fastcall SetLevelNo(int Value);

    void __fastcall MySaveMap(); // xsaɮ
    bool __fastcall AskSaveMap(); // T{O_xsa
    bool __fastcall ValidateMap(); // ˬdaϬO_Xk
    
    __property int LevelNo = {read = FLevelNo, write = SetLevelNo};
public:		// User declarations
        __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
